Attribute VB_Name = "ToBin"
Option Explicit
Private Declare Function GetLongPathNameA Lib "kernel32.dll" (ByVal lpszShortPath As String, ByVal lpszLongPath As String, ByVal cchBuffer As Long) As Long
Private Declare Sub CopyMemoryS Lib "kernel32" Alias "RtlMoveMemory" (lpvDest As Any, ByVal lpvSource As String, ByVal cbCopy As Long)

Dim Lix As Integer
Dim OFFStart As Long

Sub Main()
 Check_Moffset
End Sub

Sub Check_Moffset()
Dim Line As String
Dim offset1 As Long, offset2 As Long, NbLine As Long
Dim Buffer() As Byte
Dim Codes As Long, NbCodes As Integer

ReDim Buffer(0)

NbLine = 0
offset1 = -1
Lix = FreeFile
Open Trim(Command$) For Input As Lix

Do
'Get first Offset
Do
If EOF(Lix) Then Exit Do
Line Input #Lix, Line
NbLine = NbLine + 1
Loop While Trim(Line) = ""

If offset1 = -1 And InStr(Line, ":") > 0 And OFFStart = 0 Then offset1 = Val(Trim(Left(Line, InStr(Line, ":") - 1))): OFFStart = offset1
If InStr(Line, ":") > 0 Then offset2 = Val(Trim(Left(Line, InStr(Line, ":") - 1))) Else offset1 = -1

If offset2 <> offset1 And offset1 <> -1 Then
Debug.Print "OFFSET ERROR Line "; NbLine; ". ["; Line; "]"
End If

'Debug.Print offset,
If InStr(Line, ":") > 0 Then Line = Right(Line, Len(Line) - InStr(Line, ":"))

NbCodes = 0
'Retrieve binarys
Do
If InStr(Line, ",") > 0 Then
Codes = Val(Trim(Left(Line, InStr(Line, ","))))
Line = Trim(Right(Line, Len(Line) - InStr(Line, ",")))

If Codes > 255 Then
Debug.Print "Line "; NbLine; " code ("; Codes; ") >255."
Else
Buffer(UBound(Buffer)) = CByte(Codes)
ReDim Preserve Buffer(UBound(Buffer) + 1)
NbCodes = NbCodes + 1
End If
Else
Codes = Val(Trim(Line))

If Codes > 255 Then
Debug.Print "Line "; NbLine; " code ("; Codes; ") >255."
Else
Buffer(UBound(Buffer)) = CByte(Codes)
ReDim Preserve Buffer(UBound(Buffer) + 1)
NbCodes = NbCodes + 1
End If
Line = ""
End If
Loop Until (Trim(Line) = "" Or EOF(Lix) = True)
If offset1 <> -1 Then offset1 = offset1 + NbCodes
Loop Until EOF(Lix) = True And Trim(Line) = ""
Close #Lix
ReDim Preserve Buffer(UBound(Buffer) - 1)
Buffer(UBound(Buffer)) = 255

Lix = FreeFile
Dim SPECname As String
Dim TmpName As String * 10
SPECname = Cut_attr(Cut_Name(Trim(Command$)))
If Len(SPECname) > 8 Then TmpName = Left(SPECname, 8) Else TmpName = SPECname
Dim Header(23) As Byte


TmpName = TmpName
Header(0) = 19: Header(3) = 3
CopyMemoryS Header(4), TmpName, 10

'lenght
Header(14) = (UBound(Buffer) - 1) And 255
Header(15) = (UBound(Buffer) - 1) \ 256

'Start memory offset
Header(16) = OFFStart And 255
Header(17) = OFFStart \ 256

'End memory offset
Header(18) = 0 '(OFFStart + (UBound(Buffer) - 1)) And 255
Header(19) = &H80 '(OFFStart + (UBound(Buffer) - 1)) \ 256
Header(20) = 0

'Data Bloc lenght
Header(21) = ((UBound(Buffer) + 1)) And 255
Header(22) = ((UBound(Buffer) + 1)) \ 256

'Dim crc As Byte
'Dim chk As Integer
'For chk = 1 To 21: crc = crc Xor Header(chk): Next
'Header(22) = crc
Header(23) = 255


If Dir(SPECname & ".TAP") <> "" Then Kill (SPECname & ".TAP")
Open SPECname & ".TAP" For Binary As Lix
Put #Lix, 1, Header
Put #Lix, 25, Buffer
Close #Lix

If Dir(SPECname & ".BIN") <> "" Then Kill (SPECname & ".BIN")
Open SPECname & ".BIN" For Binary As Lix
Put #Lix, 1, Buffer
Close #Lix


End Sub

' Retrive name in a long file name string ( "c:\vb\tmp\file.txt" -> "file.txt" )
Public Function Cut_Name(ByRef Ln_file As String) As String
Dim LastSlash, scan_path As Integer
Dim char_path As String * 1
Dim lng_file As String
lng_file = GetLongPathName(Ln_file)
Ln_file = lng_file

'If Ln_file = "" Then Cut_Name = "": Exit Function
If InStr(Ln_file, "\") = 0 Then Cut_Name = Ln_file: Exit Function
   
    scan_path = Len(Ln_file)
    Do While InStr(1, Mid(Ln_file, scan_path, 1), "\", vbBinaryCompare) = 0
     scan_path = scan_path - 1
    Loop
 LastSlash = scan_path
Cut_Name = Trim(Right(Ln_file, Len(Ln_file) - LastSlash))

End Function

Public Function GetLongPathName(Shortpath As String) As String
   Dim s As String
   Dim i As Long
   
   i = 255
   s = String(i, 0)
   GetLongPathNameA Shortpath, s, i
   
   GetLongPathName = Left$(s, InStr(s, Chr$(0)) - 1)
End Function

' Internal function cut attributes "disk.TXT" = "disk"
Public Function Cut_attr(char As String) As String
Dim cmp
For cmp = Len(char) To 1 Step -1
If Mid(char, cmp, 1) = "." Then Cut_attr = Mid(char, 1, cmp - 1): Exit For
If Mid(char, cmp, 1) = "\" Then Cut_attr = char: Exit For
Next cmp
End Function
